'Simple Chat Client Ver. 0.5
'By mr_onionx 15-jan-2007
$APPTYPE GUI
$TYPECHECK ON
DEFSTR FormCaption
$INCLUDE "inc/rapidq.inc"
$IFDEF UNIX
   $OPTION GTK 
   FormCaption = "Simple Linux Chat Client ver. 0.5"
$ELSE
   FormCaption = "Simple Win Chat Client ver. 0.5"
$ENDIF
'---------------------------
DEFLNG ClientSocket = 0
DIM GetServerMsg AS STRING
DEFSTR NickName
DEFSTR NameServer
DEFSTR MSG_TO_SERVER
DEFSTR Namechannel = ""
'---------------------------
DECLARE SUB ConnectToNetWork
DECLARE SUB DisconnectFromNet
DECLARE SUB TimeExpired
DECLARE SUB SendMessage
DECLARE SUB RetrieveChannels
DECLARE SUB JoinChannel
'---------------------------
DIM Socket AS QSocket
    Socket.Family = AF_INET
    Socket.Type = SOCK_STREAM
    Socket.Protocol = IPPROTO_IP

DIM MainForm As QForm
    MainForm.Caption = FormCaption
    MainForm.Height = 500
    MainForm.Width = 400
    MainForm.BorderStyle = bsSingle
    MainForm.Center

DIM Timer1 AS QTimer
    Timer1.Interval = 100
    Timer1.OnTimer = TimeExpired
    Timer1.Enabled = False

DIM ConnectButton As QButton
    ConnectButton.Parent = MainForm
    ConnectButton.Top = 20
    ConnectButton.Left = 10
    ConnectButton.Width = 80
    ConnectButton.Height = 30
    ConnectButton.Caption = "Connect"
    ConnectButton.OnClick = ConnectToNetWork

DIM DisConnectButton As QButton
    DisConnectButton.Parent = MainForm
    DisConnectButton.Top = 20
    DisConnectButton.Left = 110
    DisConnectButton.Width = 80
    DisConnectButton.Height = 30
    DisConnectButton.Caption = "DisConnect"
    DisConnectButton.Onclick = DisconnectFromNet

DIM ChanListButton As QButton
    ChanListButton.Parent = MainForm
    ChanListButton.Top = 20
    ChanListButton.Left = 210
    ChanListButton.Width = 80
    ChanListButton.Height = 30
    ChanListButton.Caption = "List Chan"
    ChanListButton.Onclick = RetrieveChannels

DIM JoinButton As QButton
    JoinButton.Parent = MainForm
    JoinButton.Top = 20
    JoinButton.Left = 310
    JoinButton.Width = 80
    JoinButton.Height = 30
    JoinButton.Caption = "Join Chan"
    JoinButton.Onclick = JoinChannel

DIM PortLabel As QLabel
    PortLabel.Parent = MainForm
    PortLabel.Caption = "Port"
    PortLabel.Width = 50
    PortLabel.Left = 7
    PortLabel.Top = 60

DIM ServerLabel As QLabel
    ServerLabel.Parent = MainForm
    ServerLabel.Caption = "Server"
    ServerLabel.Left = 60
    ServerLabel.Top = 60

DIM NickNameLabel As QLabel
    NickNameLabel.Parent = MainForm
    NickNameLabel.Caption = "NickName"
    NickNameLabel.Left = 165
    NickNameLabel.Top = 60

DIM PortEdit As QEdit
    PortEdit.Parent = MainForm
    PortEdit.Top = 80
    PortEdit.Left = 10
    PortEdit.Width = 50
    PortEdit.Height = 20
    PortEdit.Text = "6667"

DIM ServerEdit As QEdit
    ServerEdit.Parent = MainForm
    ServerEdit.Top = 80
    ServerEdit.Left = 80
    ServerEdit.Width = 80
    ServerEdit.Height = 20
    ServerEdit.Text = "Insert One"

DIM NameChanLabel As QLabel
    NameChanLabel.Parent = MainForm
    NameChanLabel.Caption = "Channel"
    NameChanLabel.Left = 265
    NameChanLabel.Top = 60

DIM NickNameEdit As QEdit
    NickNameEdit.Parent = MainForm
    NickNameEdit.Top = 80
    NickNameEdit.Left = 180
    NickNameEdit.Width = 80
    NickNameEdit.Height = 20
    NickNameEdit.Text = "NewBie_"

DIM NameChanEdit As QEdit
    NameChanEdit.Parent = MainForm
    NameChanEdit.Top = 80
    NameChanEdit.Left = 280
    NameChanEdit.Width = 80
    NameChanEdit.Height = 20
    NameChanEdit.Text = "Insert One"

DIM ChatRoomWindow AS QRichEdit
    ChatRoomWindow.Parent  = MainForm
    'ChatRoomWindow.Enabled = False
    ChatRoomWindow.Top = 130
    ChatRoomWindow.Left = 10
    ChatRoomWindow.Height = 300
    ChatRoomWindow.Width = 380
    ChatRoomWindow.ScrollBars = ssNone
    ChatRoomWindow.ReadOnly = True   'This don't works


DIM ChatBox As Qedit
    ChatBox.Parent = MainForm
    ChatBox.MaxLength = 55
    ChatBox.top = 440
    ChatBox.Left = 10
    ChatBox.Width = 380
    ChatBox.Height = 20

DIM SendButton As QButton
    SendButton.Parent = MainForm
    SendButton.Top = 468
    SendButton.Left = 150
    SendButton.Width = 80
    SendButton.Height = 25
    SendButton.Caption = "Send MSG"
    SendButton.OnClick = SendMessage

ChatRoomWindow.AddStrings "Simple Chat Client"
ChatRoomWindow.AddStrings "Fill all fields and click on 'Connect'"
ChatRoomWindow.AddStrings "When you are connected click on 'join' to join chan"
ChatRoomWindow.AddStrings "or Type /HELP to get help from server"

MainForm.ShowModal
'-----------------------------
SUB ConnectToNetWork
    IF ClientSocket > 0 THEN ChatRoomWindow.AddStrings "Socket Already Connected..." : EXIT SUB
    Timer1.Enabled = False
    NickName = NickNameEdit.Text
    NameServer = ServerEdit.Text
    NameChannel = "#" & NameChanEdit.Text
    ClientSocket = Socket.Connect(ServerEdit.Text, VAL(PortEdit.Text)) : Sleep 1
    IF ClientSocket = 0 THEN
       ChatRoomWindow.AddStrings "Socket Error..."
       GOTO ExitConnectSub
    END IF
    ChatRoomWindow.AddStrings "Created Socket... " & STR$(ClientSocket)
    SendLoginMessage:
    Socket.WriteLine(ClientSocket,"NICK " & NickName)
    Socket.WriteLine(ClientSocket,"USER " & NickName &" "& Socket.GetHostIP &" "& NameServer &" :"& NickName)
    IF Socket.Transferred < 0 THEN
       ChatRoomWindow.AddStrings "Server Disconnected!"
       GOTO ExitConnectSub
    END IF
    Timer1.Enabled = True
ExitConnectSub:
END SUB
'-----------------------------
SUB TimeExpired
    Timer1.Enabled = False
    IF Socket.IsServerReady(ClientSocket) THEN
       GetServerMsg = Socket.ReadLine(ClientSocket)
       ChatRoomWindow.AddStrings GetServerMsg
          IF LEFT$(GetServerMsg,4) = "PING" THEN _
             Socket.WriteLine(ClientSocket, "PONG "& NameServer) : ChatRoomWindow.AddStrings "PONG " 
             IF Socket.Transferred < 0 THEN
             ChatRoomWindow.AddStrings "Server Disconnected!"
             GOTO ExitTimeExpired
          END IF
      END IF
    Timer1.Enabled = True
ExitTimeExpired:
  END SUB
'-------------------------
SUB DisconnectFromNet
    Timer1.Enabled = False
    Socket.Close(ClientSocket)
    ClientSocket = 0
    ChatRoomWindow.AddStrings "Connection Closed... "
END SUB
'-------------------------
SUB SendMessage
    IF Timer1.Enabled = False THEN ChatRoomWindow.AddStrings "You must be connected to send messages..." : GOTO ExitSendMessage
    Timer1.Enabled = False
    IF LEFT$(ChatBox.Text,1) = "/" THEN GOTO MessageToServer
    Socket.WriteLine(ClientSocket, "PRIVMSG " & NameChannel & " :" & ChatBox.Text)
    IF Socket.Transferred < 0 THEN
       ChatRoomWindow.AddStrings "Server Disconnected!"
       GOTO ExitSendMessage
    END IF 
    ChatRoomWindow.AddStrings NickName & ": " & ChatBox.Text
    ChatBox.Text = ""
    GOTO ExitSendMessageWithTimer
    
    MessageToServer:    
    MSG_TO_SERVER = RIGHT$(ChatBox.Text, LEN(ChatBox.Text)-1)
    Socket.WriteLine(ClientSocket, MSG_TO_SERVER)
    ChatBox.Text = ""
    IF Socket.Transferred < 0 THEN
       ChatRoomWindow.AddStrings "Server Disconnected!"
       GOTO ExitSendMessage
    END IF

ExitSendMessageWithTimer:
Timer1.Enabled = True
ExitSendMessage:
END SUB
'----------------------
SUB RetrieveChannels
    IF Timer1.Enabled = False THEN ChatRoomWindow.AddStrings "You must be connected to see list of channels..." : GOTO ExitRetChannels
       Timer1.Enabled = False
    MSG_TO_SERVER = "/LIST "
    Socket.WriteLine(ClientSocket, MSG_TO_SERVER)
Timer1.Enabled = True
ExitRetChannels:
END SUB
'---------------------
SUB JoinChannel
IF Timer1.Enabled = False THEN ChatRoomWindow.AddStrings "You must be connected to Join Channel..." : GOTO ExitJoinChan
       Timer1.Enabled = False
    MSG_TO_SERVER = "JOIN " & NameChannel
    Socket.WriteLine(ClientSocket, MSG_TO_SERVER)
    IF Socket.Transferred < 0 THEN
       ChatRoomWindow.AddStrings "Server Disconnected!"
       GOTO ExitJoinChan
    END IF
Timer1.Enabled = True
ExitJoinChan:
END SUB
'--------------------